import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface PostConstructAnnotationAttributes {
  name?: string[];
}

export class PostConstructAnnotation implements Annotation {
  public readonly attributes: PostConstructAnnotationAttributes;

  public constructor(name: string | string[] | PostConstructAnnotationAttributes) {

    if (undefined === name) {
      this.attributes = {
      };
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes = {
        name: [<string>name],
      };
    } else {
      this.attributes = <PostConstructAnnotationAttributes>name;
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('PostConstruct');
  }

}

export const PostConstruct = Decorator.create(PostConstructAnnotation);
