import {
  Configuration,
  Instance,
} from '@overflow/commons/application/decorators';
import { Value } from '@overflow/commons/di/decorators';

@Configuration()
export class WebAppConfiguration {
  @Value('html.container.id')
  private htmlContainerID: string;

  /**
   * container
   */
  @Instance()
  public container(): Promise<HTMLElement> {
    function getContainer(containerID: string): Promise<HTMLElement> {
      return new Promise<HTMLElement>(resolve => {
        document.addEventListener('DOMContentLoaded', () => {
          resolve(document.getElementById(containerID));
        });
      });
    }

    return getContainer(this.htmlContainerID);
  }
}
